<?php
/************************************************************************
 * This file is part of EspoCRM.
 *
 * EspoCRM - Open Source CRM application.
 * Copyright (C) 2014-2023 Yurii Kuznietsov, Taras Machyshyn, Oleksii Avramenko
 * Website: https://www.espocrm.com
 *
 * EspoCRM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EspoCRM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EspoCRM. If not, see http://www.gnu.org/licenses/.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU General Public License version 3,
 * these Appropriate Legal Notices must retain the display of the "EspoCRM" word.
 ************************************************************************/

namespace Espo\Custom\Field\Address;

use Espo\ORM\Entity;
use Espo\ORM\Value\ValueFactory;

use Espo\Core\Field\Address;

class AddressFactory implements ValueFactory
{
    public function isCreatableFromEntity(Entity $entity, string $field): bool
    {
        return true;
    }

    public function createFromEntity(Entity $entity, string $field): Address
    {
        return (new AddressBuilder())
           ->setStreet($entity->get($field . 'Street'))
           ->setCity($entity->get($field . 'City'))
           ->setCountry($entity->get($field . 'Country'))
           ->setState($entity->get($field . 'State'))
           ->setPostalCode($entity->get($field . 'PostalCode'))
           ->setNumber($entity->get($field . 'Number'))
           ->setLkz($entity->get($field . 'Lkz'))
           ->setArea($entity->get($field . 'Area'))
           ->setSpecific($entity->get($field . 'Specific'))
           ->build();
    }
}
